var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';

import Form, { withLayout } from 'react-jsonschema-form';

import { exportFormDataValeus, formDataValues, formDefaultValues, formToJSONSchema, formToUISchema } from './formTransformer';

import CustomArrayField from './widgets/CustomArrayField';
import CustomFieldTemplate from './widgets/CustomFieldTemplate';
import H1Widget from './widgets/H1Widget';
import TextFieldWidget from './widgets/mui/TextFieldWidget';
import TextareaWidget from './widgets/mui/TextareaWidget';
import DatePickerWidget from './widgets/mui/DatePickerWidget';
import RadioGroupWidget from './widgets/mui/RadioGroupWidget';
import CheckboxesGroupWidget from './widgets/mui/CheckboxesGroupWidget';
import MultipleUploadWidget from './widgets/mui/MultipleUploadWidget';

import 'whatwg-fetch';

import 'bootstrap-grid/dist/grid.css';
import './index.css';

function FormDinamicoReactRender(props) {
    var onChange = props.onChange,
        onSubmit = props.onSubmit,
        form = props.form,
        formData = props.formData,
        children = props.children,
        environment = props.environment,
        customWidgets = props.customWidgets,
        rest = _objectWithoutProperties(props, ['onChange', 'onSubmit', 'form', 'formData', 'children', 'environment', 'customWidgets']);

    var handleChange = function handleChange(event) {
        var formData = event.formData;

        onChange(exportFormDataValeus(formData));
    };

    var handleSubmit = function handleSubmit(event) {
        var formData = event.formData;

        onSubmit(exportFormDataValeus(formData));
    };

    var formProps = _extends({}, rest, {
        className: 'container-fluid',
        schema: formToJSONSchema(form),
        uiSchema: formToUISchema(form, environment),
        formData: _extends({}, formDefaultValues(form), formDataValues(formData)),
        FieldTemplate: CustomFieldTemplate,
        fields: {
            ArrayField: CustomArrayField
        },
        onChange: handleChange,
        onSubmit: handleSubmit
    });

    var formWidgets = _extends({
        TextareaWidget: TextareaWidget,
        TextWidget: TextFieldWidget,
        dateWidget: DatePickerWidget,
        h1Widget: H1Widget,
        radio: RadioGroupWidget,
        checkboxes: CheckboxesGroupWidget,
        'file-multiple': MultipleUploadWidget
    }, customWidgets);

    var FormWithLayout = withLayout(Form);

    return React.createElement(
        FormWithLayout,
        _extends({}, formProps, {
            widgets: formWidgets
        }),
        children
    );
}

FormDinamicoReactRender.propTypes = process.env.NODE_ENV !== "production" ? {
    form: PropTypes.shape({
        elements: PropTypes.array
    }).isRequired,
    formData: PropTypes.any,
    customWidgets: PropTypes.object,
    /* event handlers */
    onChange: PropTypes.func,
    onError: PropTypes.func,
    onSubmit: PropTypes.func,
    /**/
    environment: PropTypes.shape({
        upload: PropTypes.shape({
            url: PropTypes.string.isRequired,
            config: PropTypes.object.isRequired
        }),
        customProps: PropTypes.object
    })
} : {};

export default FormDinamicoReactRender;